# Kör som root handbok

&Geert.Jansen; &Geert.Jansen.mail;
Stefan
Asserhäll

    stefan.asserhall@comhem.se

Översättare
2000
&Geert.Jansen;
&FDLNotice;
2002-01-18
1.00.00

Kör som root är ett grafiskt gränssnitt för &UNIX;-kommandot `su`.

KDE
su
lösenord
root

## Inledning

Välkommen till Kör som root! Kör som root är ett grafiskt gränssnitt för &UNIX;-kommandot `su` för skrivbordsmiljön KDE. Det låter dig köra ett program som en annan användare genom att ange lösenordet för den användaren. Kör som root är ett program utan särskilda behörigheter. Det använder systemets `su`.

Kör som root har ytterligare en funktion: det kan komma ihåg lösenord åt dig. Om du använder den här funktionen behöver du bara ange lösenordet en gång för varje kommando. Se för mer information om det här och en säkerhetsanalys.

Det är meningen att det här programmet ska startas från kommandoraden eller från `.desktop`-filer. Även om det frågar efter root-lösenordet med en grafisk dialogruta, anser jag att det är mer som en kommandorad <-> grafiskt gränssnitt koppling, än ett program med ett rent grafiskt gränssnitt.

## Att använda Kör som root

Användningen av Kör som root är enkel. Syntaxen är så här:

    kdesu ANVÄNDARE -n -t -q -d -f FIL -c   KOMMANDO ARGUMENT1 ARGUMENT2

    kdesu  -v -h -s

Kommandoradsparametrarna förklaras nedan.

`-c PROGRAM`

  Det här anger programmet som ska köras som root. Det måste skickas som en parameter. Så om du till exempel vill starta en ny filhanterare, skulle du skriva in ``kdesu `-c kfm -sw``` på kommandoraden.

`-f FILE`

  Den här parametern tillåter effektiv användning av Kör som root i `.desktop`-filer. Det talar om för Kör som root att det ska titta i filen som anges av `FILE`. Om den här filen är skrivbar för den nuvarande användaren körs kommandot som det nuvarande användaren. Om den inte är skrivbar, körs kommandot som användaren `USER` (standardvärde är root).

  `FILE` utvärderas så här: om `FILE` börjar med ett `/`, anses den vara ett absolut filnamn. Annars antas den vara namnet på en global &kde; konfigurationsfil. För att till exempel ställa in K inloggningshanteraren, kdm, skulle du kunna skriva `kdesu `-c kdmconfig -f kdmrc``

`-t`

  Aktivera terminalutmatning. Det här stänger av funktionen att behålla lösenord. Det här är enbart för avlusningssyfte. Om du vill köra ett kommandoradsprogram, använd det vanliga `su` istället.

`-n`

  Behåll inte lösenordet. Det här gör att kryssrutan Kom ihåg lösenord inte visas i lösenordsdialogrutan.

`-q`

  Var tyst.

`-d`

  Visa avlusningsinformation.

`-v`

  Skriv ut versionsinformation och avsluta.

`-h`

  Skriv ut lite hjälp.

`-s`

  Avbryt kdesu-demonen. Se .

## Inställningar

Kör som root levereras med en inställningsmodul som heter kcmkdesu. Du hittar den i K-menyn under Inställningar Personligt Lösenord.

Ekoläge

  Det här är hur tecken som du skriver in ekas på skärmen. Möjliga val är: en stjärna per tecken, tre stjärnor per tecken eller inget eko alls. Förvalt värde är en stjärna per tecken.

Behålla lösenord

  Du kan tala om för Kör som root att komma ihåg lösenorden du skriver in genom att markera Kom ihåg lösenord. Om den här är markerad, kan du skriva in en tidsgräns i textrutan nedanför. Det här är tiden, i minuter, att komma ihåg lösenordet. Förval är att inte komma ihåg lösenord.

## Interna funktioner

### X-identifiering

Programmet du startar kör med användaridentiteten root och har i allmänhet inga behörigheter att komma åt din X-skärm. Kör som root kommer runt detta genom att lägga till en identifieringskaka för din skärm i en tillfällig `.Xauthority`-fil. Efter kommandot avslutats, tas den här filen bort.

Om du inte använder X-kakor, är du utelämnad till dig själv. Kör som root upptäcker det här och lägger inte till en kaka, men du måste försäkra dig om att root har behörigheter att komma åt din skärm.

### Gränssnitt med `su`

Kör som root använder systemets `su` kommando för att erhålla behörigheter. I det här avsnittet förklarar jag detaljerna om hur Kör som root gör det här.

Eftersom vissa `su`-implementeringar (dvs. den från Redhat) inte vill läsa lösenordet från `stdin`, så skapar Kör som root ett pty/tty-par och kör `su` med dess standard fildeskriptorer anslutna till tty:n.

För att köra kommandot som användaren valt, istället för ett interaktivt skal, använder Kör som root parametern `-c` till `su`. Den här parametern förstås av alla skal som jag känner till, så det här bör vara flyttningsbart. `Su` skickar parametern `-c` till den slutliga användarens skal, och skalet kör programmet. Exempel på kommando: `su `root -c programmet``.

I stället för att köra användarkommandot direkt med `su`, startar Kör som root ett litet stödprogram som heter kdesu_stub. Detta stödprogram (som kör som målanvändaren), begär en del information från Kör som root över pty/tty-kanalen (stödprogrammets stdin och stdout) och kör sedan användarens program. Informationen som skickas över är: X-skärmen, en X-identifieringskaka (om tillgänglig), `PATH` och kommandot som ska köras. Orsaken att ett stödprogram används är att X-kakan är privat information och kan därför inte skickas på kommandoraden.

### Lösenordskontroll

Kör som root kontrollerar lösenordet som du skrivit in och ger ett felmeddelande om det inte är riktigt. Kontrollen görs genom att köra ett testprogram: `/bin/true`. Om det här lyckas, antas lösenordet vara riktigt.

### Kom ihåg lösenord

För din bekvämlighet implementerar Kör som root en funktion för att behålla lösenord. Om du är intresserad av säkerhet, bör du läsa det här stycket.

Att låta Kör som root komma ihåg lösenord öppnar en (liten) säkerhetslucka i ditt system. Uppenbarligen låter inte Kör som root någon annan än din användaridentitet använda lösenorden, men, om det görs utan försiktighet, sänker detta säkerhetsnivån för root till en vanlig användares nivå (din). En hackare som bryter sig in i ditt konto, skulle komma åt root. Kör som root försöker hindra detta. Säkerhetsmetoden som används är, iallafall enligt min mening, rimligt säker och förklaras här.

Kör som root använder en demon, som kallas kdesud. Demonen lyssnar med ett &UNIX;-uttag (socket) i `/tmp` efter kommandon. Uttagets behörigheter är 0600, så att bara din användaridentitet kan ansluta till det. Om funktionen att komma ihåg lösenord är aktiverad, startar Kör som root kommandon via den här demonen. Det skriver kommandon och root-lösenordet till uttaget och demonen kör kommandot med `su`, som beskrivits ovan. Därefter slängs inte kommandot och lösenordet som beskrivits ovan, utan de behålls en angiven tid. Det här är tidsgränsen från inställningsmodulen. Om en annan förfrågan med samma kommando anländer inom den här tidsperioden, behöver inte klienten ange lösenordet. För att förhindra att hackare som brutit sig in i ditt konto stjäl lösenorden från demonen (till exempel genom att ansluta en avlusare), installeras demonen som en set-group-id med ingen grupp. Detta bör förhindra alla normala användare (inklusive dig själv) från att ta reda på lösenord från kdesud-processen. Dessutom sätter demonen `DISPLAY`-miljövariabeln till värdet den hade när den startade. Det enda en hackare kan göra är att köra ett program på din skärm.

En svaghet med den här metoden är att program som du kör förmodligen inte är skrivna med säkerhet i åtanke (som setuid root-program). Det betyder att de kan ha buffrar som blir överfulla eller andra problem, och att en hackare skulle kunna utnyttja dessa.

Användning av funktionen att komma ihåg lösenord är en kompromiss mellan säkerhet och bekvämlighet. Jag uppmuntrar dig att tänka igenom och bestämma själv om du vill använda den eller inte.

## Upphovsman

Kör som root

Copyright 2000 &Geert.Jansen;

Kör som root är skrivet av &Geert.Jansen;. Det är till viss del baserat på Pietro Iglios Kör som root, version 0.3. Pietro och jag kom överens om att jag ska underhålla det här programmet i framtiden.

Upphovsmannen kan nås via e-post på &Geert.Jansen.mail;. Rapportera alla fel du hittar så att jag kan rätta dem. Om du har ett förslag, tveka inte att kontakta mig.

&underFDL; &underArtisticLicense;